//---------------------------------------------------------------------------

#include <vcl.h>

#pragma hdrstop

#include "Barcode.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TBarcode *)
{
    new TBarcode(NULL);
}
//---------------------------------------------------------------------------
__fastcall TBarcode::TBarcode(TComponent* Owner)
    : TImage(Owner)
{
	Width = 210;
	Height = 146;
	BarcodeID = "4770148114995";
}

void __fastcall TBarcode::SetBarcodeID(const String barcode) {
    if (barcode.Length() != 13) {
	    ShowMessage("Barcode ID length must be 13 numbers");
	    return;
    }

    String encTable[3][10];
    int parityToEnc[10][8];

    parityToEnc[1][2] = 0;
    parityToEnc[1][3] = 0;
    parityToEnc[1][4] = 1;
    parityToEnc[1][5] = 0;
    parityToEnc[1][6] = 1;
    parityToEnc[1][7] = 1;
    parityToEnc[2][2] = 0;
    parityToEnc[2][3] = 0;
    parityToEnc[2][4] = 1;
    parityToEnc[2][5] = 1;
    parityToEnc[2][6] = 0;
    parityToEnc[2][7] = 1;
    parityToEnc[3][2] = 0;
    parityToEnc[3][3] = 0;
    parityToEnc[3][4] = 1;
    parityToEnc[3][5] = 1;
    parityToEnc[3][6] = 1;
    parityToEnc[3][7] = 0;
    parityToEnc[4][2] = 0;
    parityToEnc[4][3] = 1;
    parityToEnc[4][4] = 0;
    parityToEnc[4][5] = 0;
    parityToEnc[4][6] = 1;
    parityToEnc[4][7] = 1;
    parityToEnc[5][2] = 0;
    parityToEnc[5][3] = 1;
    parityToEnc[5][4] = 1;
    parityToEnc[5][5] = 0;
    parityToEnc[5][6] = 0;
    parityToEnc[5][7] = 1;
    parityToEnc[6][2] = 0;
    parityToEnc[6][3] = 1;
    parityToEnc[6][4] = 1;
    parityToEnc[6][5] = 1;
    parityToEnc[6][6] = 0;
    parityToEnc[6][7] = 0;
    parityToEnc[7][2] = 0;
    parityToEnc[7][3] = 1;
    parityToEnc[7][4] = 0;
    parityToEnc[7][5] = 1;
    parityToEnc[7][6] = 0;
    parityToEnc[7][7] = 1;
    parityToEnc[8][2] = 0;
    parityToEnc[8][3] = 1;
    parityToEnc[8][4] = 0;
    parityToEnc[8][5] = 1;
    parityToEnc[8][6] = 1;
    parityToEnc[8][7] = 0;
    parityToEnc[9][2] = 0;
    parityToEnc[9][3] = 1;
    parityToEnc[9][4] = 1;
    parityToEnc[9][5] = 0;
    parityToEnc[9][6] = 1;
    parityToEnc[9][7] = 0;

    encTable[0][0] = "0001101";
    encTable[0][1] = "0011001";
    encTable[0][2] = "0010011";
    encTable[0][3] = "0111101";
    encTable[0][4] = "0100011";
    encTable[0][5] = "0110001";
    encTable[0][6] = "0101111";
    encTable[0][7] = "0111011";
    encTable[0][8] = "0110111";
    encTable[0][9] = "0001011";
    encTable[1][0] = "0100111";
    encTable[1][1] = "0110011";
    encTable[1][2] = "0011011";
    encTable[1][3] = "0100001";
    encTable[1][4] = "0011101";
    encTable[1][5] = "0111001";
    encTable[1][6] = "0000101";
    encTable[1][7] = "0010001";
    encTable[1][8] = "0001001";
    encTable[1][9] = "0010111";
    encTable[2][0] = "1110010";
    encTable[2][1] = "1100110";
    encTable[2][2] = "1101100";
    encTable[2][3] = "1000010";
    encTable[2][4] = "1011100";
    encTable[2][5] = "1001110";
    encTable[2][6] = "1010000";
    encTable[2][7] = "1000100";
    encTable[2][8] = "1001000";
    encTable[2][9] = "1110100";

    String lastString = "";

    lastString += "101";

    for (int i = 2; i <= 7; ++i) {
        String firstDigit_s = barcode[1];
        int firstDigit_i = firstDigit_s.ToInt();
        String curDigit_s = barcode[i];
        int curDigit_i = curDigit_s.ToInt();
        lastString += encTable[parityToEnc[firstDigit_i][i]][curDigit_i];
    }

    lastString += "01010";

    for (int i = 8; i <= 13; ++i) {
        String curDigit_s = barcode[i];
        int curDigit_i = curDigit_s.ToInt();
        lastString += encTable[2][curDigit_i];
    }

    lastString += "101";

    Graphics::TBitmap *Bitmap;
    Bitmap = new Graphics::TBitmap;

    Bitmap->Width =210;
    Bitmap->Height =146;
    Picture->Graphic = Bitmap;
    Picture->Bitmap->Canvas->Pen->Color = clBlack;

    for (int i = 1; i <= 190; i = i + 2) {
        if (lastString[(i+1)/2] == '1') {
            if (i <= 6 || (i >= 90 && i <= 100) || i >= 184) {
                Picture->Bitmap->Canvas->MoveTo(i+14,10);
                Picture->Bitmap->Canvas->LineTo(i+14,136);
                Picture->Bitmap->Canvas->MoveTo(i+15,10);
                Picture->Bitmap->Canvas->LineTo(i+15,136);
            } else {
                Picture->Bitmap->Canvas->MoveTo(i+14,10);
                Picture->Bitmap->Canvas->LineTo(i+14,123);
                Picture->Bitmap->Canvas->MoveTo(i+15,10);
                Picture->Bitmap->Canvas->LineTo(i+15,123);
            }
        }
    }

    Picture->Bitmap->Canvas->Font->Name = "Arial";
    Picture->Bitmap->Canvas->Font->Color = clBlack;
    Picture->Bitmap->Canvas->Font->Size = 11;
    Picture->Bitmap->Canvas->TextOut(4, 116, barcode[1]);
    Picture->Bitmap->Canvas->TextOut(30, 123, ((String)barcode[2] + " " + barcode[3] + " " + barcode[4] + " " + barcode[5] + " " + barcode[6] + " " + barcode[7]));
    Picture->Bitmap->Canvas->TextOut(121, 123, ((String)barcode[8] + " " + barcode[9] + " " + barcode[10] + " " + barcode[11] + " " + barcode[12] + " " + barcode[13]));

    FBarcodeID = barcode;
}
//---------------------------------------------------------------------------
namespace Barcode
{
    void __fastcall PACKAGE Register()
    {
         TComponentClass classes[1] = {__classid(TBarcode)};
         RegisterComponents("Barcode", classes, 0);
    }
}
//---------------------------------------------------------------------------
